/* -
 * Copyright (c) 2002, Ramsey G. Brenner. <rgbrenner@myrealbox.com>
 * All rights reserved.
 *
 * The contents of this file are subject to the terms of the XORSuite
 * Public Source License (the "License"); You may not use this file except
 * in compliance with the License. You may obtain a copy of the License
 * at http://rgbrenner.cjb.net/projects/xpsl.html.
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 */

typedef unsigned char bgen_t;

enum tf {
    FALSE,
    TRUE
};
typedef enum tf tf;

enum HASH_ALGO {
    MD,
    SH
};
typedef enum HASH_ALGO HASH_ALGO;

struct HASH_DATA {
    int              digest_length;
    char            *hash,
                     sh_hash[(SHA_DIGEST_LENGTH * 2) + 1],
                     md_hash[(MD5_DIGEST_LENGTH * 2) + 1];
    void            *c,
                   (*init)(void),
                   (*update)(unsigned char *),
                   (*final)(void),
                   (*end)(void),
                   (*zero)(char **, unsigned char **, void *);
    size_t           c_size;
    MD5_CTX          md_c;
    SHA_CTX          sh_c;
    HASH_ALGO        algo;
    unsigned char   *md,
                     sh_md[SHA_DIGEST_LENGTH],
                     md_md[MD5_DIGEST_LENGTH];
};
typedef struct HASH_DATA HASH_DATA;

enum BGEN_ALGO {
    URANDOM,
    SSL
};
typedef enum BGEN_ALGO BGEN_ALGO;

enum opt_t {
    OTHER,
    HASH_MD5,
    HASH_SHA1,
    BGEN_SSL,
    BGEN_URANDOM,
    OUTPUT_FILE,
    SIZE,
    FFLAG,
    N_OPT
};
typedef enum opt_t opt_t;

enum err_codes {
    OPEN,
    READ,
    WRITE,
    RENAME,
    DIROPEN,
    BYTE_GEN,
    MISSING_FILE,
    HASH_MISMATCH
};
typedef enum err_codes err_code;

struct F_REG {
    char          *fn;
    FILE          *fp;
    struct F_REG  *next;
};
typedef struct F_REG F_REG;
